[![Coverage Status](https://coveralls.io/repos/github/jasonmunro/cypht/badge.svg?branch=master)](https://coveralls.io/github/jasonmunro/cypht?branch=master)
[![CII Best Practices](https://bestpractices.coreinfrastructure.org/projects/127/badge)](https://bestpractices.coreinfrastructure.org/projects/127)

#### Cypht
[https://cypht.org](https://cypht.org)

All your email, from all your accounts, in one place. Supports IMAP/SMTP, 
[JMAP](https://github.com/cypht-org/cypht/issues/180) and 
[soon EWS](https://github.com/cypht-org/cypht/issues/247). Cypht is like a 
news reader, but for E-mail. Cypht does not replace your existing accounts - it 
combines them into one. And it's also a news reader.

![screenshot](https://github.com/cypht-org/cypht-website/blob/master/img/Inbox.PNG "Inbox View").

The driving force behind Cypht development is to provide combined views for
multiple accounts, but it's also a standard E-mail client that lets you browse
and manage IMAP folders and send outbound messages with SMTP.


Cypht is an application built entirely of plugins, or as we call them, module
sets (which is obviously way cooler sounding than plugins), that are executed
by the framework. Modules provide a flexible way to add new features or
customize the program without hacking the code.


Installation instructions
* Cypht master: [https://cypht.org/install.html](https://cypht.org/install.html)
* Version 1: [https://cypht.org/install-1x.html](https://cypht.org/install-1x.html)
* Version 2: [https://cypht.org/install-2x.html](https://cypht.org/install-2x.html)

Security details: [https://cypht.org/security.html](https://cypht.org/security.html)

Module info: [https://cypht.org/modules.html](https://cypht.org/modules.html)

Features: [https://cypht.org/features.html](https://cypht.org/features.html)

License: [https://cypht.org/license.html](https://cypht.org/license.html)

Community chat room: [https://gitter.im/cypht-org/community](https://gitter.im/cypht-org/community)

For developers, get via Composer: [https://packagist.org/packages/jason-munro/cypht](https://packagist.org/packages/jason-munro/cypht)

Docker: [https://hub.docker.com/r/cypht/cypht](https://hub.docker.com/r/cypht/cypht)

LinkedIn group: [https://www.linkedin.com/groups/13804559/](https://www.linkedin.com/groups/13804559/)

An interview with the project's founder: https://github.com/cypht-org/cypht/wiki/AMA-Jason-Munro
